//#####################################################################
// Copyright 2012.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#ifndef __PROJECT_FFT__
#define __PROJECT_FFT__

#include <Core/Arrays/ARRAY.h>
#include <Core/Arrays/FACE_ARRAYS.h>
#include <Core/Grids/FACE_INDEX.h>
#include <Core/Grids/GRID.h>

namespace PhysBAM
{

// #if 0
// int shift=0; // offset shift to i+shift
// #else
// int shift=-1; // offset shift to i+shift
// #endif

template<class TV>
struct CONSTRAINT_STENCIL
{
    typedef typename TV::SCALAR T;
    ARRAY<std::pair<FACE_INDEX<TV::m>,T>> constraints;
};

template<class T,int d,class TV>
void Project_Stencils(const GRID<TV>& grid,ARRAY<T,FACE_INDEX<d>>& mac,
    const ARRAY<CONSTRAINT_STENCIL<TV>>& stencil,T tol=1e-6);

template<class TV,class IV,class T,int d>
void Test_Stencils(const ARRAY<T,FACE_INDEX<d>>& mac,const IV& size,const GRID<TV>& grid,
    const ARRAY<CONSTRAINT_STENCIL<TV>>& stencil);

template<class T,class TV>
void Make_Div_Stencil(ARRAY<CONSTRAINT_STENCIL<TV>>& out,const ARRAY<T>& in);

template<class T,class TV>
void Make_Curl_Stencil(ARRAY<CONSTRAINT_STENCIL<TV>>& out,const ARRAY<T>& in);

template<class TV,class IV,class T,int d>
void Test_Div(const ARRAY<T,FACE_INDEX<d>>& mac,const IV& size,const GRID<TV>& grid,
    const ARRAY<T>& stencil);

template<class TV,class IV,class T,int d>
void Test_Curl(const ARRAY<T,FACE_INDEX<d>>& mac,const IV& size,const GRID<TV>& grid,
    const ARRAY<T>& stencil);

// ARRAY<T> stencil={-1,1};
// ARRAY<T> stencil={1./24,-27./24,27./24,-1./24};
template<class T,int d,class TV>
void Project_Div(const GRID<TV>& grid,ARRAY<T,FACE_INDEX<d>>& mac,
    const ARRAY<T>& stencil,T tol=1e-6);

template<class T,int d,class TV>
void Project_Curl(const GRID<TV>& grid,ARRAY<T,FACE_INDEX<d>>& mac,
    const ARRAY<T>& stencil,T tol=1e-6);
}
#endif

