#!/bin/bash
(
function f()
{
    N=$1
    OPT="$2"
    Y=$3
    D=$4
    T=$5
    UL=$6
    rm -f path-grid-data.txt
    echo ./path-grid $OPT -dim $D
    ./path-grid $OPT -dim $D || exit 1
    sed 's/[()]//g' < path-grid-data.txt > path-grid-data-$N.txt
    cp path-grid-data-$N.txt 2021/
    mv path-grid-data-$N.txt 2022/
    for U in $UL ; do
        mv path-grid-cross-$U.txt 2022/path-grid-cross-$U-$N.txt
        for y in 2021 2022 ; do
            sed -e "s/QQ/$U/g" -e "s/FFF/$N/g" -e "s/YMAX/$Y/g" -e "s/TTT/$T/" -e "s/NNN/$D/" < path-grid-$y.tex > $y/path-grid-$U-$N.tex
            if [ $U = w ] && [ $N = D ] ; then
                sed -i -e "s/{-$Y}/{-$Y*5}/g" -e "s/{$Y}/{$Y*5}/g" $y/path-grid-$U-$N.tex
            fi
            ( cd $y ; pdflatex path-grid-$U-$N.tex ) &
        done
    done
}

mkdir 2021 2022

f A "-vel 0" 0.9 2 " for $\\\\mathbf{u}_{2a}$ (2D)" "u v"
f B "-vel 1 -err" 0.005 2 "error for $\\\\mathbf{u}_{2b}$ (2D)" "u v"
f C "-vel 0" 0.9 3 " for $\\\\mathbf{u}_{3a}$ (3D)" "u v w"
f D "-vel 1 -err" 0.003 3 "error for $\\\\mathbf{u}_{3b}$ (3D)" "u v w"
wait
)
